import { AnyAction } from 'redux';
import * as actionTypes from '../action_types';
import { OperationAction, DeleteOperationAction, OpId } from '../typedefs';
export declare enum OpsBlueprintActionKey {
    Start = "start",
    Success = "success",
    Error = "error",
    Delete = "delete"
}
export declare type OpsBlueprintActionTypes = {
    readonly STARTED: string;
    readonly INTERMEDIATE: string;
    readonly SUCCESS: string;
    readonly ERROR: string;
};
export interface OpsBlueprintAction {
    readonly type: string;
    [actionTypes.prefix]: OpsBlueprintActionData;
}
export interface OpsBlueprintActionData extends OpsBlueprintGenericActionData {
    op: OperationAction | DeleteOperationAction;
    action?: OpsBlueprintOriginalAction | null;
}
export interface OpsBlueprintGenericActionData {
    uniqueId?: OpId;
    broadcast?: boolean;
}
export interface OpsBlueprintOriginalAction extends AnyAction {
    [actionTypes.prefix]?: OpsBlueprintGenericActionData;
}
export interface OpsBlueprintActionCreator {
    (data?: any, action?: OpsBlueprintOriginalAction | null): OpsBlueprintAction;
}
declare type OpsOpsBlueprintActionCreator = (...args: any[]) => any;
export declare type BlueprintActionComposers = {
    [key in OpsBlueprintActionKey]?: OpsOpsBlueprintActionCreator;
};
export declare type ComposedActionCreator = OpsBlueprintActionCreator | OpsOpsBlueprintActionCreator;
export declare type OpsBlueprint = {
    [key in OpsBlueprintActionKey]: ComposedActionCreator;
} & {
    readonly id: OpId;
};
export declare type OpsBlueprintFn<T extends (...args: any) => any> = (...args: Parameters<T>) => OpsBlueprintAction;
export {};
